#pragma once

#include <iostream>
#include <future>
#include <thread>

#include <opencv2/opencv.hpp>

#include <input.h>
#include <processing.h>
#include <control_module.h>
#include <interpreter.h>
#include <intersection_handler.h>


using namespace cv;

class LFR
{
    Input input;
    Processing processing;
    ControlModule controlModule;
    Interpreter interpreter;
    IntersectionHandler intersectionHandler;
    volatile bool iAmLooping;
    void loop();
    thread loopThread;
    int threshold_binary;

public:

    LFR() = delete;
    LFR(int video_height, int video_width, int threshold_binary);
    ~LFR();

    void startLoop();
    void endLoop();
    
};